#include <AMS.h>
#include <Wire.h>
#include <Arduino.h>
float Pressure;
float Temperature;
float Flow;
int PressureInt;
byte Flow_shift;
byte Pressure_shift;
byte combine;
String DataString;
String p="p";
String f="f";
String pressure;
String flow;
String package;
String ending="e";
char PrintData[48];
int offset = 32768; // Offset for the sensor
float scale = 800.0; 

AMS AMSa(5915, 0x28,0,2068); //dovrebbe essere 0x28 l'i2c address del AMS 5915
volatile bool get_temp;


hw_timer_t * timer = NULL; 

portMUX_TYPE timerMux = portMUX_INITIALIZER_UNLOCKED;
   


// With critical section
void IRAM_ATTR onTime() {
    portENTER_CRITICAL_ISR(&timerMux);
    get_temp= true;
    portEXIT_CRITICAL_ISR(&timerMux);
}

void setup() {
    Serial.begin(115200);
  
    // Configure Prescaler to 80, as our timer runs @ 80Mhz
    // Giving an output of 80,000,000 / 80 = 1,000,000 ticks / second
    Wire.begin();
    int a = 0;
    int b = 0;
    int c = 0; 
   
    delay(1000);
  
    Wire.beginTransmission(byte(0x40)); // transmit to device #064 (0x40)
    Wire.write(byte(0x10));      //
    Wire.write(byte(0x00));      //
    Wire.endTransmission(); 
  
    delay(5);
  
    Wire.requestFrom(0x40, 3); //
    a = Wire.read(); // first received byte stored here
    b = Wire.read(); // second received byte stored here
    c = Wire.read(); // third received byte stored here
    Wire.endTransmission();
    Serial.print(a);
    Serial.print(b);
    Serial.println(c);
  
    delay(5);
   
    Wire.requestFrom(0x40, 3); //
    a = Wire.read(); // first received byte stored here
    b = Wire.read(); // second received byte stored here
    c = Wire.read(); // third received byte stored here
    Wire.endTransmission();
    Serial.print(a);
    Serial.print(b);
    Serial.println(c);
    timer = timerBegin(0, 80, true);                
    timerAttachInterrupt(timer, &onTime, true);    
    
    // Sets an alarm to sound every second
    timerAlarmWrite(timer, 1000000, true);           
    timerAlarmEnable(timer);
    delay(5);
}

void loop() {
  if(get_temp=true){
    get_temp=false;
    if (AMSa.Available() == true) {
    Pressure = AMSa.readPressure();
    if (isnan(Pressure)) {
      Serial.write("Please check the sensor family name.");
    } 
    else {
      String stringOne = String(Pressure, 5);
      pressure=p+stringOne;
    }
  } 
  else {
    Serial.write("The sensor did not answer.");
  }
 
  Wire.requestFrom(0x40, 2); // read 2 bytes from device with address 0x40
  uint8_t b[2];
  b[1] = Wire.read(); // 
  b[0] = Wire.read(); 
  uint16_t c {0};
  c = (b[1] << 8) | b[0];// second received byte stored here
  float Flow = ((float)c - offset) / scale;
  String stringOne1 = String(Flow, 4); //ricorda che era 4
  flow=f+stringOne1;
  //Serial.println(flow);
  package=pressure+flow+ending;
  Serial.println(package);
  }
}
