#include <Arduino.h>
#include <AMS.h>
#include <Wire.h>
volatile float Pressure;
volatile float Flow;
int PressureInt;
byte Flow_shift;
byte Pressure_shift;
byte combine;
String DataString;
String p="p";
String f="f";
String pressure;
String flow;
String package;
String ending="e";
int offset = 32768; // Offset for the sensor
float scale = 800.0; 
volatile bool flag;
volatile int count;

AMS AMSa(5915, 0x28,0,2068); //dovrebbe essere 0x28 l'i2c address del AMS 5915


hw_timer_t * timer = NULL;
portMUX_TYPE timerMux = portMUX_INITIALIZER_UNLOCKED;

// Code with critica section
void IRAM_ATTR onTime() {
  
   portENTER_CRITICAL_ISR(&timerMux);
   flag =true;
   Wire.requestFrom(0x28, 2);
   Pressure = AMSa.readPressure();
   Wire.requestFrom(0x40, 2); // read 2 bytes from device with address 0x40
   uint8_t b[2];
   b[1] = Wire.read(); // 
   b[0] = Wire.read(); //10 100 nano condensatore
   uint16_t c {0};
   c = (b[1] << 8) | b[0];// second received byte stored here
   float Flow = ((float)c - offset) / scale;
   portEXIT_CRITICAL_ISR(&timerMux);
}

void setup() {
   Serial.begin(115200);
   flag = false;
  
   timer = timerBegin(0, 80, true);                
   timerAttachInterrupt(timer, &onTime, true);    
    
   // Sets an alarm to sound every second
   timerAlarmWrite(timer, 1000000, true);           
   timerAlarmEnable(timer);
    Wire.begin();
    int a = 0;
    int b = 0;
    int c = 0; 
   
    delay(1000);
  
    Wire.beginTransmission(byte(0x40)); // transmit to device #064 (0x40)
    Wire.write(byte(0x10));      //
    Wire.write(byte(0x00));      //
    Wire.endTransmission(); 
  
    delay(5);
  
    Wire.requestFrom(0x40, 3); //
    a = Wire.read(); // first received byte stored here
    b = Wire.read(); // second received byte stored here
    c = Wire.read(); // third received byte stored here
    Wire.endTransmission();
    Serial.print(a);
    Serial.print(b);
    Serial.println(c);
  
    delay(5);
   
    Wire.requestFrom(0x40, 3); //
    a = Wire.read(); // first received byte stored here
    b = Wire.read(); // second received byte stored here
    c = Wire.read(); // third received byte stored here
    Wire.endTransmission();
    Serial.print(a);
    Serial.print(b);
    Serial.println(c);
    delay(5);
}

void loop() {
  if(flag){
    flag =false;
    String stringOne = String(Pressure, 5);
    pressure=p+stringOne;
    String stringOne1 = String(Flow, 4);
    flow=f+stringOne1;
    package=pressure+flow+ending;
    Serial.println(package);
  }
}
